package crop.sample.df;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "crop.sample.df", "crop.sample.df.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "crop.sample.df", "crop.sample.df.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "crop.sample.df.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _sourceimagerect = null;
public static anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _touchimageviewrect = null;
public uk.co.martinpearman.b4a.touchimageview.TouchImageViewWrapper _touchimageview1 = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel3 = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _imageview1 = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _imageview2 = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _imageview3 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public static boolean _salvouprimeira = false;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"Button1",mostCurrent._button1,"Button2",mostCurrent._button2,"ImageView1",mostCurrent._imageview1,"ImageView2",mostCurrent._imageview2,"ImageView3",mostCurrent._imageview3,"Panel2",mostCurrent._panel2,"Panel3",mostCurrent._panel3,"salvouprimeira",_salvouprimeira,"SourceImageRect",_sourceimagerect,"TouchImageView1",mostCurrent._touchimageview1,"TouchImageViewRect",_touchimageviewrect};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
try {
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent,34);
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bitmap1 = null;
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 34;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(2);
 BA.debugLineNum = 37;BA.debugLine="TouchImageView1.Initialize(\"TouchImageView1\")";
Debug.ShouldStop(16);
mostCurrent._touchimageview1.Initialize(mostCurrent.activityBA,"TouchImageView1");
 BA.debugLineNum = 38;BA.debugLine="Activity.AddView(TouchImageView1, 0, 0, 100%x, 100%y)";
Debug.ShouldStop(32);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._touchimageview1.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 BA.debugLineNum = 39;BA.debugLine="TouchImageView1.MinScale=1.0 'ZOOM MÍNIMO";
Debug.ShouldStop(64);
mostCurrent._touchimageview1.setMinScale((float) (1.0));
 BA.debugLineNum = 40;BA.debugLine="TouchImageView1.MaxScale=2		 'ZOOM MÁXIMO";
Debug.ShouldStop(128);
mostCurrent._touchimageview1.setMaxScale((float) (2));
 BA.debugLineNum = 41;BA.debugLine="TouchImageView1.TranslatePaddingX = 50%x 'BLOQUEIA IMAGEM DE SAIR DA TELA X HORIZONTAL";
Debug.ShouldStop(256);
mostCurrent._touchimageview1.setTranslatePaddingX(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA));
 BA.debugLineNum = 42;BA.debugLine="TouchImageView1.TranslatePaddingY = 60%Y 'BLOQUEIA IMAGEM DE SAIR DA TELA Y VERTICAL";
Debug.ShouldStop(512);
mostCurrent._touchimageview1.setTranslatePaddingY(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (60),mostCurrent.activityBA));
 BA.debugLineNum = 43;BA.debugLine="TouchImageView1.Color = Colors.Black 'DEFINE A COR DE FUNDO COMO PRETO";
Debug.ShouldStop(1024);
mostCurrent._touchimageview1.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 45;BA.debugLine="Dim Bitmap1 As Bitmap";
Debug.ShouldStop(4096);
_bitmap1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("Bitmap1", _bitmap1);
 BA.debugLineNum = 46;BA.debugLine="Bitmap1.Initialize(File.DirAssets, \"loko.jpg\")  'CARREGA IMAGEM A SER USADO CROP";
Debug.ShouldStop(8192);
_bitmap1.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"loko.jpg");
 BA.debugLineNum = 47;BA.debugLine="TouchImageView1.SetBitmap(Bitmap1)";
Debug.ShouldStop(16384);
mostCurrent._touchimageview1.SetBitmap(mostCurrent.activityBA,(android.graphics.Bitmap)(_bitmap1.getObject()));
 BA.debugLineNum = 49;BA.debugLine="SourceImageRect.Initialize(0, 0, Bitmap1.Width, Bitmap1.Height )";
Debug.ShouldStop(65536);
_sourceimagerect.Initialize((int) (0),(int) (0),_bitmap1.getWidth(),_bitmap1.getHeight());
 BA.debugLineNum = 50;BA.debugLine="TouchImageViewRect.Initialize(0, 0, TouchImageView1.Width, TouchImageView1.Height)";
Debug.ShouldStop(131072);
_touchimageviewrect.Initialize((int) (0),(int) (0),mostCurrent._touchimageview1.getWidth(),mostCurrent._touchimageview1.getHeight());
 BA.debugLineNum = 51;BA.debugLine="TouchImageView1.ScaleSrcRectToDestRect(SourceImageRect, TouchImageViewRect, \"CENTER\")";
Debug.ShouldStop(262144);
mostCurrent._touchimageview1.ScaleSrcRectToDestRect((android.graphics.Rect)(_sourceimagerect.getObject()),(android.graphics.Rect)(_touchimageviewrect.getObject()),"CENTER");
 BA.debugLineNum = 52;BA.debugLine="Activity.LoadLayout(\"1\") 'CARREGA NOSSO LAYOUT POR CIMA COM OS OS 2 PAINEIS UM TRANSPARENTE 100% E OUTRO QUE É CROP CENTRALIZADO";
Debug.ShouldStop(524288);
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 BA.debugLineNum = 56;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
try {
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent,61);
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 61;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 62;BA.debugLine="End Sub";
Debug.ShouldStop(536870912);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
try {
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent,58);
 BA.debugLineNum = 58;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 59;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _button1_click() throws Exception{
try {
		Debug.PushSubsStack("Button1_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent,65);
anywheresoftware.b4a.objects.drawable.CanvasWrapper _cvs = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bitmap1 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _srcrect = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _destrect = null;
anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper _out = null;
String _filename = "";
 BA.debugLineNum = 65;BA.debugLine="Sub Button1_Click";
Debug.ShouldStop(1);
 BA.debugLineNum = 66;BA.debugLine="If salvouprimeira = False Then";
Debug.ShouldStop(2);
if (_salvouprimeira==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 68;BA.debugLine="Dim cvs As Canvas";
Debug.ShouldStop(8);
_cvs = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();Debug.locals.put("cvs", _cvs);
 BA.debugLineNum = 69;BA.debugLine="cvs.Initialize(TouchImageView1)";
Debug.ShouldStop(16);
_cvs.Initialize((android.view.View)(mostCurrent._touchimageview1.getObject()));
 BA.debugLineNum = 71;BA.debugLine="Dim Bitmap1 As Bitmap";
Debug.ShouldStop(64);
_bitmap1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("Bitmap1", _bitmap1);
 BA.debugLineNum = 72;BA.debugLine="Bitmap1.Initialize3(TouchImageView1.TransformedBitmap)";
Debug.ShouldStop(128);
_bitmap1.Initialize3((android.graphics.Bitmap)(mostCurrent._touchimageview1.getTransformedBitmap().getObject()));
 BA.debugLineNum = 74;BA.debugLine="Dim SrcRect As Rect";
Debug.ShouldStop(512);
_srcrect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();Debug.locals.put("SrcRect", _srcrect);
 BA.debugLineNum = 75;BA.debugLine="SrcRect.Initialize( Panel2.Left , Panel2.Top , Panel2.Left + Panel2.Width ,Panel2.Top + Panel2.Height)";
Debug.ShouldStop(1024);
_srcrect.Initialize(mostCurrent._panel2.getLeft(),mostCurrent._panel2.getTop(),(int) (mostCurrent._panel2.getLeft()+mostCurrent._panel2.getWidth()),(int) (mostCurrent._panel2.getTop()+mostCurrent._panel2.getHeight()));
 BA.debugLineNum = 77;BA.debugLine="Dim DestRect As Rect";
Debug.ShouldStop(4096);
_destrect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();Debug.locals.put("DestRect", _destrect);
 BA.debugLineNum = 78;BA.debugLine="DestRect.Initialize(0%x,0%y,100%x,100%y)";
Debug.ShouldStop(8192);
_destrect.Initialize(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (0),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 BA.debugLineNum = 80;BA.debugLine="cvs.DrawBitmap(Bitmap1,SrcRect,DestRect)";
Debug.ShouldStop(32768);
_cvs.DrawBitmap((android.graphics.Bitmap)(_bitmap1.getObject()),(android.graphics.Rect)(_srcrect.getObject()),(android.graphics.Rect)(_destrect.getObject()));
 BA.debugLineNum = 81;BA.debugLine="Dim out As OutputStream";
Debug.ShouldStop(65536);
_out = new anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper();Debug.locals.put("out", _out);
 BA.debugLineNum = 82;BA.debugLine="Dim filename As String";
Debug.ShouldStop(131072);
_filename = "";Debug.locals.put("filename", _filename);
 BA.debugLineNum = 83;BA.debugLine="filename = \"img.png\"";
Debug.ShouldStop(262144);
_filename = "img.png";Debug.locals.put("filename", _filename);
 BA.debugLineNum = 84;BA.debugLine="out = File.OpenOutput (File.DirDefaultExternal, filename ,  False)";
Debug.ShouldStop(524288);
_out = anywheresoftware.b4a.keywords.Common.File.OpenOutput(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),_filename,anywheresoftware.b4a.keywords.Common.False);Debug.locals.put("out", _out);
 BA.debugLineNum = 85;BA.debugLine="cvs.Bitmap.WriteToStream(out,  100, \"PNG\")";
Debug.ShouldStop(1048576);
_cvs.getBitmap().WriteToStream((java.io.OutputStream)(_out.getObject()),(int) (100),BA.getEnumFromString(android.graphics.Bitmap.CompressFormat.class,"PNG"));
 BA.debugLineNum = 86;BA.debugLine="Log(cvs.Bitmap.Width & \"x\" & cvs.Bitmap.Height)";
Debug.ShouldStop(2097152);
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_cvs.getBitmap().getWidth())+"x"+BA.NumberToString(_cvs.getBitmap().getHeight()));
 BA.debugLineNum = 87;BA.debugLine="out.Close";
Debug.ShouldStop(4194304);
_out.Close();
 BA.debugLineNum = 89;BA.debugLine="If File.Exists(File.DirDefaultExternal, \"img.png\") Then";
Debug.ShouldStop(16777216);
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"img.png")) { 
 BA.debugLineNum = 90;BA.debugLine="ImageView2.Bitmap = LoadBitmapSample(File.DirDefaultExternal, \"img.png\", ImageView2.Width, ImageView2.Height)";
Debug.ShouldStop(33554432);
mostCurrent._imageview2.setBitmap((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmapSample(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"img.png",mostCurrent._imageview2.getWidth(),mostCurrent._imageview2.getHeight()).getObject()));
 BA.debugLineNum = 91;BA.debugLine="Panel2.SetLayout(25%x, 10%y, 75%x - 25%x, 70%y)";
Debug.ShouldStop(67108864);
mostCurrent._panel2.SetLayout(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (25),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (10),mostCurrent.activityBA),(int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (75),mostCurrent.activityBA)-anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (25),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (70),mostCurrent.activityBA));
 BA.debugLineNum = 92;BA.debugLine="salvouprimeira = True";
Debug.ShouldStop(134217728);
_salvouprimeira = anywheresoftware.b4a.keywords.Common.True;
 };
 }else {
 BA.debugLineNum = 96;BA.debugLine="Dim cvs As Canvas";
Debug.ShouldStop(-2147483648);
_cvs = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();Debug.locals.put("cvs", _cvs);
 BA.debugLineNum = 97;BA.debugLine="cvs.Initialize(TouchImageView1)";
Debug.ShouldStop(1);
_cvs.Initialize((android.view.View)(mostCurrent._touchimageview1.getObject()));
 BA.debugLineNum = 99;BA.debugLine="Dim Bitmap1 As Bitmap";
Debug.ShouldStop(4);
_bitmap1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("Bitmap1", _bitmap1);
 BA.debugLineNum = 100;BA.debugLine="Bitmap1.Initialize3(TouchImageView1.TransformedBitmap)";
Debug.ShouldStop(8);
_bitmap1.Initialize3((android.graphics.Bitmap)(mostCurrent._touchimageview1.getTransformedBitmap().getObject()));
 BA.debugLineNum = 102;BA.debugLine="Dim SrcRect As Rect";
Debug.ShouldStop(32);
_srcrect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();Debug.locals.put("SrcRect", _srcrect);
 BA.debugLineNum = 103;BA.debugLine="SrcRect.Initialize( Panel2.Left , Panel2.Top , Panel2.Left + Panel2.Width ,Panel2.Top + Panel2.Height)";
Debug.ShouldStop(64);
_srcrect.Initialize(mostCurrent._panel2.getLeft(),mostCurrent._panel2.getTop(),(int) (mostCurrent._panel2.getLeft()+mostCurrent._panel2.getWidth()),(int) (mostCurrent._panel2.getTop()+mostCurrent._panel2.getHeight()));
 BA.debugLineNum = 105;BA.debugLine="Dim DestRect As Rect";
Debug.ShouldStop(256);
_destrect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();Debug.locals.put("DestRect", _destrect);
 BA.debugLineNum = 106;BA.debugLine="DestRect.Initialize(0%x,0%y,100%x,100%y)";
Debug.ShouldStop(512);
_destrect.Initialize(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (0),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 BA.debugLineNum = 108;BA.debugLine="cvs.DrawBitmap(Bitmap1,SrcRect,DestRect)";
Debug.ShouldStop(2048);
_cvs.DrawBitmap((android.graphics.Bitmap)(_bitmap1.getObject()),(android.graphics.Rect)(_srcrect.getObject()),(android.graphics.Rect)(_destrect.getObject()));
 BA.debugLineNum = 109;BA.debugLine="Dim out As OutputStream";
Debug.ShouldStop(4096);
_out = new anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper();Debug.locals.put("out", _out);
 BA.debugLineNum = 110;BA.debugLine="Dim filename As String";
Debug.ShouldStop(8192);
_filename = "";Debug.locals.put("filename", _filename);
 BA.debugLineNum = 111;BA.debugLine="filename = \"bg.png\"";
Debug.ShouldStop(16384);
_filename = "bg.png";Debug.locals.put("filename", _filename);
 BA.debugLineNum = 112;BA.debugLine="out = File.OpenOutput (File.DirDefaultExternal, filename ,  False)";
Debug.ShouldStop(32768);
_out = anywheresoftware.b4a.keywords.Common.File.OpenOutput(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),_filename,anywheresoftware.b4a.keywords.Common.False);Debug.locals.put("out", _out);
 BA.debugLineNum = 113;BA.debugLine="cvs.Bitmap.WriteToStream(out,  100, \"PNG\")";
Debug.ShouldStop(65536);
_cvs.getBitmap().WriteToStream((java.io.OutputStream)(_out.getObject()),(int) (100),BA.getEnumFromString(android.graphics.Bitmap.CompressFormat.class,"PNG"));
 BA.debugLineNum = 114;BA.debugLine="Log(cvs.Bitmap.Width & \"x\" & cvs.Bitmap.Height)";
Debug.ShouldStop(131072);
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_cvs.getBitmap().getWidth())+"x"+BA.NumberToString(_cvs.getBitmap().getHeight()));
 BA.debugLineNum = 115;BA.debugLine="out.Close";
Debug.ShouldStop(262144);
_out.Close();
 BA.debugLineNum = 117;BA.debugLine="If File.Exists(File.DirDefaultExternal, \"bg.png\") Then";
Debug.ShouldStop(1048576);
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"bg.png")) { 
 BA.debugLineNum = 118;BA.debugLine="ImageView1.Bitmap = LoadBitmapSample(File.DirDefaultExternal, \"bg.png\", ImageView1.Width, ImageView1.Height)";
Debug.ShouldStop(2097152);
mostCurrent._imageview1.setBitmap((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmapSample(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"bg.png",mostCurrent._imageview1.getWidth(),mostCurrent._imageview1.getHeight()).getObject()));
 BA.debugLineNum = 119;BA.debugLine="Panel3.Visible = True";
Debug.ShouldStop(4194304);
mostCurrent._panel3.setVisible(anywheresoftware.b4a.keywords.Common.True);
 };
 };
 BA.debugLineNum = 123;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _button2_click() throws Exception{
try {
		Debug.PushSubsStack("Button2_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent,125);
 BA.debugLineNum = 125;BA.debugLine="Sub Button2_Click";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 126;BA.debugLine="Panel3.Visible = False";
Debug.ShouldStop(536870912);
mostCurrent._panel3.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 127;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 8959, new int[] {4}, "6f4a4085-6d25-4cf2-b2d4-37a658231490");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 23;BA.debugLine="Dim TouchImageView1 As TouchImageView";
mostCurrent._touchimageview1 = new uk.co.martinpearman.b4a.touchimageview.TouchImageViewWrapper();
 //BA.debugLineNum = 24;BA.debugLine="Private Panel2 As Panel";
mostCurrent._panel2 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Private Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Private Panel3 As Panel";
mostCurrent._panel3 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Private ImageView1 As ImageView";
mostCurrent._imageview1 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Private ImageView2 As ImageView";
mostCurrent._imageview2 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Private ImageView3 As ImageView";
mostCurrent._imageview3 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Private Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Private salvouprimeira As Boolean = False";
_salvouprimeira = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 32;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 18;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="Dim SourceImageRect, TouchImageViewRect As Rect";
_sourceimagerect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
_touchimageviewrect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
}
